From 4d7dba0a36362b23a25c043e0627c1f97b4e3717 Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 1 Jul 2020 10:06:03 +0300
Subject: [PATCH 27/59] AlpineApkTransaction: transaction should know its
 backend

---
 .../AlpineApkBackend/AlpineApkTransaction.cpp | 28 +++++++++----------
 .../AlpineApkBackend/AlpineApkTransaction.h   | 27 ++++++++++--------
 2 files changed, 29 insertions(+), 26 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.cpp
index b4f90df56..fdc1d0534 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.cpp
@@ -26,7 +26,6 @@
 #include <QDebug>
 #include <KRandom>
 
-// #define TEST_PROCEED
 
 AlpineApkTransaction::AlpineApkTransaction(AlpineApkResource *app, Role role)
     : AlpineApkTransaction(app, {}, role)
@@ -36,12 +35,25 @@ AlpineApkTransaction::AlpineApkTransaction(AlpineApkResource *app, Role role)
 AlpineApkTransaction::AlpineApkTransaction(AlpineApkResource *app, const AddonList &addons, Transaction::Role role)
     : Transaction(app->backend(), app, role, addons)
     , m_app(app)
+    , m_backend(static_cast<AlpineApkBackend *>(app->backend()))
 {
-    setCancellable(true);
+    setCancellable(false);
     setStatus(DownloadingStatus);
     iterateTransaction();
 }
 
+void AlpineApkTransaction::proceed()
+{
+    finishTransaction();
+}
+
+void AlpineApkTransaction::cancel()
+{
+    m_iterate = false;
+
+    setStatus(CancelledStatus);
+}
+
 void AlpineApkTransaction::iterateTransaction()
 {
     if (!m_iterate) {
@@ -59,18 +71,6 @@ void AlpineApkTransaction::iterateTransaction()
     }
 }
 
-void AlpineApkTransaction::proceed()
-{
-    finishTransaction();
-}
-
-void AlpineApkTransaction::cancel()
-{
-    m_iterate = false;
-
-    setStatus(CancelledStatus);
-}
-
 void AlpineApkTransaction::finishTransaction()
 {
     AbstractResource::State newState;
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.h b/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.h
index 63aeef8d7..ba0a77502 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkTransaction.h
@@ -23,24 +23,27 @@
 
 #include <Transaction/Transaction.h>
 
+class AlpineApkBackend;
 class AlpineApkResource;
+
 class AlpineApkTransaction : public Transaction
 {
-    Q_OBJECT
-    public:
-        AlpineApkTransaction(AlpineApkResource *app, Role role);
-        AlpineApkTransaction(AlpineApkResource *app, const AddonList &list, Role role);
+Q_OBJECT
+public:
+    AlpineApkTransaction(AlpineApkResource *app, Role role);
+    AlpineApkTransaction(AlpineApkResource *app, const AddonList &list, Role role);
 
-        void cancel() override;
-        void proceed() override;
+    void cancel() override;
+    void proceed() override;
 
-    private Q_SLOTS:
-        void iterateTransaction();
-        void finishTransaction();
+private Q_SLOTS:
+    void iterateTransaction();
+    void finishTransaction();
 
-    private:
-        bool m_iterate = true;
-        AlpineApkResource *m_app;
+private:
+    bool m_iterate = true;
+    AlpineApkResource *m_app;
+    AlpineApkBackend *m_backend;
 };
 
 #endif // ALPINEAPKTRANSACTION_H
-- 
GitLab


